# Gio::Settings Class Reference

A high-level API for application settings. More...

`#include <giomm/settings.h>`

Inheritance diagram for Gio::Settings:
[legend]

List of all members.

## Public Member Functions

virtual | ~Settings ()
GSettings* | gobj ()
| Provides access to the underlying C GObject.
const GSettings* | gobj () const
| Provides access to the underlying C GObject.
GSettings* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_int (const Glib::ustring& key) const
| Gets the value that is stored at key in settings.
void | set_int (const Glib::ustring& key, int value)
| Sets key in settings to value.
bool | get_boolean (const Glib::ustring& key) const
| Gets the value that is stored at key in settings.
void | set_boolean (const Glib::ustring& key, bool value)
| Sets key in settings to value.
Glib::ustring | get_string (const Glib::ustring& key) const
| Gets the value that is stored at key in settings.
void | set_string (const Glib::ustring& key, const Glib::ustring&value)
| Sets key in settings to value.
double | get_double (const Glib::ustring& key) const
| Gets the value that is stored at key in settings.
void | set_double (const Glib::ustring& key, double value)
| Sets key in settings to value.
Glib::StringArrayHandle | get_string_array (const Glib::ustring& key) const
| Gets the value that is stored at key in settings.
bool | set_string_array (const Glib::ustring& key, const Glib::StringArrayHandle&value)
| Sets key in settings to value.
Glib::RefPtr< Settings > | get_child (const Glib::ustring& name)
| Creates a 'child' settings object which has a base path of <replaceable>base-path</replaceable>/ name, where <replaceable>base-path</replaceable> is the base path of settings.
Glib::RefPtr< const Settings > | get_child (const Glib::ustring& name) const
| Creates a 'child' settings object which has a base path of <replaceable>base-path</replaceable>/ name, where <replaceable>base-path</replaceable> is the base path of settings.
bool | is_writable (const Glib::ustring& key) const
| Finds out if a key can be written or not.
void | delay ()
| Changes the Settings object into 'delay-apply' mode.
void | apply ()
| Applies any changes that have been made to the settings.
void | revert ()
| Reverts all non-applied changes to the settings.
bool | get_has_unapplied () const
| Returns whether the Settings object has any unapplied changes.
void | bind (const Glib::ustring& key, Glib::ObjectBase* object, const Glib::ustring& property, SettingsBindFlags flags=SETTINGS_BIND_DEFAULT)
| Create a binding between the key in the settings object and the property property of object.
void | bind (const Glib::ustring& key, const Glib::PropertyProxy_Base& property_proxy, SettingsBindFlags flags=SETTINGS_BIND_DEFAULT)
void | bind_writable (const Glib::ustring& key, Glib::ObjectBase* object, const Glib::ustring& property, bool inverted=false)
| Create a binding between the writability of key in the settings object and the property property of object.
void | bind_writable (const Glib::ustring& key, const Glib::PropertyProxy_Base& property_proxy, bool inverted=false)
Glib::SignalProxy1< void, const Glib::ustring& > | signal_changed ()
Glib::SignalProxy1< void, const Glib::ustring& > | signal_writable_changed ()

## Static Public Member Functions

static Glib::RefPtr< Settings > | create (const Glib::ustring& schema)
static Glib::RefPtr< Settings > | create (const Glib::ustring& schema, const Glib::ustring& path)
static Glib::RefPtr< Settings > | create (const Glib::ustring& schema, const Glib::ustring& context, const Glib::ustring& path)
static Glib::RefPtr< Settings > | create_with_context (const Glib::ustring& schema, const Glib::ustring& context)

## Protected Member Functions

| Settings (const Glib::ustring& schema)
| Settings (const Glib::ustring& schema, const Glib::ustring& path)
| Settings (const Glib::ustring& schema, const Glib::ustring& context, const Glib::ustring& path)
virtual void | on_changed (const Glib::ustring& key)
virtual void | on_writable_changed (const Glib::ustring& key)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gio::Settings > | wrap (GSettings* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A high-level API for application settings.

The Settings class provides a convenient API for storing and retrieving application settings.

Since glibmm 2.26:

## Constructor & Destructor Documentation

virtual Gio::Settings::~Settings | ( |  | ) | `[virtual]`

Gio::Settings::Settings | ( | const Glib::ustring& | schema | ) | `[explicit, protected]`

Gio::Settings::Settings | ( | const Glib::ustring& | schema,
|  | const Glib::ustring& | path |
| ) |  |  | `[explicit, protected]`

Gio::Settings::Settings | ( | const Glib::ustring& | schema,
|  | const Glib::ustring& | context,
|  | const Glib::ustring& | path |
| ) |  |  | `[explicit, protected]`

## Member Function Documentation

void Gio::Settings::apply | ( |  | ) |

Applies any changes that have been made to the settings.

This function does nothing unless settings is in 'delay-apply' mode; see Glib::settings_set_delay_apply(). In the normal case settings are always applied immediately.

void Gio::Settings::bind | ( | const Glib::ustring& | key,
|  | const Glib::PropertyProxy_Base& | property_proxy,
|  | SettingsBindFlags | flags = `SETTINGS_BIND_DEFAULT` |
| ) |  |  |

void Gio::Settings::bind | ( | const Glib::ustring& | key,
|  | Glib::ObjectBase* | object,
|  | const Glib::ustring& | property,
|  | SettingsBindFlags | flags = `SETTINGS_BIND_DEFAULT` |
| ) |  |  |

Create a binding between the key in the settings object and the property property of object.

The binding uses the default GIO mapping functions to map between the settings and property values. These functions handle booleans, numeric types and string types in a straightforward way. Use g_settings_bind_with_mapping() if you need a custom mapping, or map between types that are not supported by the default mapping functions.

Unless the flags include SETTINGS_BIND_NO_SENSITIVITY, this function also establishes a binding between the writability of key and the "sensitive" property of object (if object has a boolean property by that name). See g_settings_bind_writable() for more details about writable bindings.

Note that the lifecycle of the binding is tied to the object, and that you can have only one binding per object property. If you bind the same property twice on the same object, the second binding overrides the first one.

Since glibmm 2.26:

Parameters:

  | key | The key to bind.
  | object | A Object.
  | property | The name of the property to bind.
  | flags | Flags for the binding.

void Gio::Settings::bind_writable | ( | const Glib::ustring& | key,
|  | const Glib::PropertyProxy_Base& | property_proxy,
|  | bool | inverted = `false` |
| ) |  |  |

void Gio::Settings::bind_writable | ( | const Glib::ustring& | key,
|  | Glib::ObjectBase* | object,
|  | const Glib::ustring& | property,
|  | bool | inverted = `false` |
| ) |  |  |

Create a binding between the writability of key in the settings object and the property property of object.

The property must be boolean; "sensitive" or "visible" properties of widgets are the most likely candidates.

Writable bindings are always uni-directional; changes of the writability of the setting will be propagated to the object property, not the other way.

When the inverted argument is `true`, the binding inverts the value as it passes from the setting to the object, i.e. property will be set to `true` if the key is <emphasis>not</emphasis> writable.

Note that the lifecycle of the binding is tied to the object, and that you can have only one binding per object property. If you bind the same property twice on the same object, the second binding overrides the first one.

Since glibmm 2.26:

Parameters:

  | key | The key to bind.
  | object | A Object.
  | property | The name of a boolean property to bind.
  | inverted | Whether to 'invert' the value.

static Glib::RefPtr<Settings> Gio::Settings::create | ( | const Glib::ustring& | schema,
|  | const Glib::ustring& | context,
|  | const Glib::ustring& | path |
| ) |  |  | `[static]`

static Glib::RefPtr<Settings> Gio::Settings::create | ( | const Glib::ustring& | schema,
|  | const Glib::ustring& | path |
| ) |  |  | `[static]`

static Glib::RefPtr<Settings> Gio::Settings::create | ( | const Glib::ustring& | schema | ) | `[static]`

static Glib::RefPtr<Settings> Gio::Settings::create_with_context | ( | const Glib::ustring& | schema,
|  | const Glib::ustring& | context |
| ) |  |  | `[static]`

void Gio::Settings::delay | ( |  | ) |

Changes the Settings object into 'delay-apply' mode.

In this mode, changes to settings are not immediately propagated to the backend, but kept locally until g_settings_apply() is called.

Since glibmm 2.26:

bool Gio::Settings::get_boolean | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for booleans.

It is a programmer error to pass a key that isn't valid for settings or is not of type boolean.

Since glibmm 2.26:

Parameters:

  | key | The key to get the value for.

Returns:
  A boolean.

Glib::RefPtr<const Settings> Gio::Settings::get_child | ( | const Glib::ustring& | name | ) | const

Creates a 'child' settings object which has a base path of <replaceable>base-path</replaceable>/ name, where <replaceable>base-path</replaceable> is the base path of settings.

The schema for the child settings object must have been declared in the schema of settings using a <tag class="starttag">child</tag> element.

Since glibmm 2.26:

Parameters:

  | name | The name of the 'child' schema.

Returns:
  A 'child' settings object.

Glib::RefPtr<Settings> Gio::Settings::get_child | ( | const Glib::ustring& | name | ) |

Creates a 'child' settings object which has a base path of <replaceable>base-path</replaceable>/ name, where <replaceable>base-path</replaceable> is the base path of settings.

The schema for the child settings object must have been declared in the schema of settings using a <tag class="starttag">child</tag> element.

Since glibmm 2.26:

Parameters:

  | name | The name of the 'child' schema.

Returns:
  A 'child' settings object.

double Gio::Settings::get_double | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for doubles.

It is a programmer error to pass a key that isn't valid for settings or is not of type double.

Since glibmm 2.26:

Parameters:

  | key | The key to get the value for.

Returns:
  A double.

bool Gio::Settings::get_has_unapplied | ( |  | ) | const

Returns whether the Settings object has any unapplied changes.

This can only be the case if it is in 'delayed-apply' mode.

Since glibmm 2.26:

Returns:
  `true` if settings has unapplied changes.

int Gio::Settings::get_int | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for 32-bit integers.

It is a programmer error to pass a key that isn't valid for settings or is not of type int32.

Since glibmm 2.26:

Parameters:

  | key | The key to get the value for.

Returns:
  An integer.

Glib::ustring Gio::Settings::get_string | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for strings.

It is a programmer error to pass a key that isn't valid for settings or is not of type string.

Since glibmm 2.26:

Parameters:

  | key | The key to get the value for.

Returns:
  A newly-allocated string.

Glib::StringArrayHandle Gio::Settings::get_string_array | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for string arrays.

It is a programmer error to pass a key that isn't valid for settings or is not of type 'string array'.

Since glibmm 2.26:

Parameters:

  | key | The key to get the value for.

Returns:
  A newly-allocated, `0`-terminated array of strings.

const GSettings* Gio::Settings::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GSettings* Gio::Settings::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GSettings* Gio::Settings::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::Settings::is_writable | ( | const Glib::ustring& | key | ) | const

Finds out if a key can be written or not.

Since glibmm 2.26:

Parameters:

  | name | The name of a key.

Returns:
  `true` if the key name is writable.

virtual void Gio::Settings::on_changed | ( | const Glib::ustring& | key | ) | `[protected, virtual]`

virtual void Gio::Settings::on_writable_changed | ( | const Glib::ustring& | key | ) | `[protected, virtual]`

void Gio::Settings::revert | ( |  | ) |

Reverts all non-applied changes to the settings.

This function does nothing unless settings is in 'delay-apply' mode; see Glib::settings_set_delay_apply(). In the normal case settings are always applied immediately.

Change notifications will be emitted for affected keys.

void Gio::Settings::set_boolean | ( | const Glib::ustring& | key,
|  | bool | value |
| ) |  |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for booleans.

It is a programmer error to pass a key that isn't valid for settings or is not of type boolean.

Since glibmm 2.26:

Parameters:

  | key | The name of the key to set.
  | value | The value to set it to.

Returns:
  `true` if setting the key succeeded, `false` if the key was not writable.

void Gio::Settings::set_double | ( | const Glib::ustring& | key,
|  | double | value |
| ) |  |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for doubles.

It is a programmer error to pass a key that isn't valid for settings or is not of type double.

Since glibmm 2.26:

Parameters:

  | key | The name of the key to set.
  | value | The value to set it to.

Returns:
  `true` if setting the key succeeded, `false` if the key was not writable.

void Gio::Settings::set_int | ( | const Glib::ustring& | key,
|  | int | value |
| ) |  |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for 32-bit integers.

It is a programmer error to pass a key that isn't valid for settings or is not of type int32.

Since glibmm 2.26:

Parameters:

  | key | The name of the key to set.
  | value | The value to set it to.

Returns:
  `true` if setting the key succeeded, `false` if the key was not writable.

void Gio::Settings::set_string | ( | const Glib::ustring& | key,
|  | const Glib::ustring& | value |
| ) |  |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for strings.

It is a programmer error to pass a key that isn't valid for settings or is not of type string.

Since glibmm 2.26:

Parameters:

  | key | The name of the key to set.
  | value | The value to set it to.

Returns:
  `true` if setting the key succeeded, `false` if the key was not writable.

bool Gio::Settings::set_string_array | ( | const Glib::ustring& | key,
|  | const Glib::StringArrayHandle& | value |
| ) |  |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for string arrays.

It is a programmer error to pass a key that isn't valid for settings or is not of type 'string array'.

Since glibmm 2.26:

Parameters:

  | key | The name of the key to set.
  | value | The value to set it to.

Returns:
  `true` if setting the key succeeded, `false` if the key was not writable.

Glib::SignalProxy1< void,const Glib::ustring& > Gio::Settings::signal_changed | ( |  | ) |

Prototype:
  `void on_my_changed(const Glib::ustring& key)`

Glib::SignalProxy1< void,const Glib::ustring& > Gio::Settings::signal_writable_changed | ( |  | ) |

Prototype:
  `void on_my_writable_changed(const Glib::ustring& key)`

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Settings > wrap | ( | GSettings * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.